/*
 * Copyright (c) 2010 Aalto University and RWTH Aachen University.
 *
 * Permission is hereby granted, free of charge, to any person
 * obtaining a copy of this software and associated documentation
 * files (the "Software"), to deal in the Software without
 * restriction, including without limitation the rights to use,
 * copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following
 * conditions:
 *
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
 * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
 * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 * OTHER DEALINGS IN THE SOFTWARE.
 */

/**
 * @file
 * @author Thomas Jansen
 * @author Christof Mroz <christof.mroz@rwth-aachen.de>
 */

#ifndef HIP_FIREWALL_MIDAUTH_H
#define HIP_FIREWALL_MIDAUTH_H

#define _BSD_SOURCE

#include <stdint.h>
#include <stdbool.h>

#include "firewall_defines.h"

#define MIDAUTH_DEFAULT_NONCE_LENGTH 18

extern bool use_midauth;

void midauth_init(void);

int hipfw_midauth_add_challenge(struct hip_fw_context *const ctx,
                                uint8_t *const midauth_nonce);
int hipfw_midauth_verify_challenge(const struct hip_fw_context *const ctx,
                                   const uint8_t *const midauth_nonce);

#endif /* HIP_FIREWALL_MIDAUTH_H */
